'*********************************************************************************************
' led-remote.bas
' Turn on left and right LEDs depending on the input values from the radio receiver.
' Forward - right LED on
' Reverse - left LED on
' Right - both LEDs on
' Left - flash both LEDs
' PicBasic Pro compiler - MicroEngineering Labs.  
'*********************************************************************************************

trisa = %00000011			' set porta pins 0&1 to inputs
trisb = %00001000			' set portb pin 3 to input

                      			' define variables and constants
piezo        var      PORTB.4
right_led    var      PORTB.0
left_led     var      PORTB.1
chan_1       var      PORTA.0
chan_2       var      PORTA.1
Channel_1    var      byte
Channel_2    var      byte
I            var      byte

low left_led						' turn off left LED
low right_led						' turn off right LED

sound piezo,[100,10,50,5,70,10,50,2]			' Make startup sound
                                               
main:

     pulsin chan_1,1,channel_1
     pulsin chan_2,1,channel_2

     If channel_2 > 180 then
        sound piezo,[100,10,50,5]			' Make sound
        high right_led                                  ' turn on right LED
        low left_led
     endif
     
     If channel_2 < 120 then
        sound piezo,[50,5,100,10,30,20]			' Make sound
        low right_led
        high left_led                                   'turn on left LED
     endif
     
     If channel_1 < 120 then
        sound piezo,[115,10,80,5,50,20]			' Make sound
        high right_led                                  ' Turn on both LEDs
        high left_led
     endif
        
     If channel_1 > 180 then
        sound piezo,[50,20,80,5,115,10]			' Make sound
        for I = 1 to 7                                  ' flash both LEDs
            high right_led
            high left_led
            pause 100
            low right_led
            low left_led
            pause 100
        next I
     endif

Goto main

End


